#include "MyRobot.h"

// Sets up the robot's member objects.
MyRobot::MyRobot() {
  // Construct member objects here.
  stick = new Joystick(1);

  leftDrive = new Victor(1);
  rightDrive = new Victor(2);

  ballGate = new Relay(1);
}

// Runs once when the robot enters disabled mode.
void MyRobot::DisabledInit() {
}

// Loops at 100 HZ during disabled mode.
void MyRobot::DisabledPeriodic() {
  // Feed the watchdog so that the robot doesn't disable itself for safety.
  GetWatchdog().Feed();
}

// Runs once when the robot enters autonomous mode.
void MyRobot::AutonInit() {
}

// Loops at 100 Hz during autonomous mode.
void MyRobot::AutonPeriodic() {
  // Feed the watchdog so that the robot doesn't disable itself for safety.
  GetWatchdog().Feed();
}

// Runs once when the robot enters teleoperated mode.
void MyRobot::TeleopInit() {
}

// Loops at 100 Hz during teleoperated mode.
void MyRobot::TeleopPeriodic() {
  // Feed the watchdog so that the robot doesn't disable itself for safety.
  GetWatchdog().Feed();

  // Control the robot using the X and Y axes of one joystick.
  float leftOutput = Limit(stick->GetY() - stick->GetX());
  float rightOutput = Limit(stick->GetY() + stick->GetX());
  leftDrive->Set(leftOutput);
  rightDrive->Set(-rightOutput);

  // Make the ball-restraining gate respond to the joystick trigger and top buttons.
  if (stick->GetTrigger() == true) {
    ballGate->Set(Relay::kForward);
  }
  else if (stick->GetTop() == true) {
	ballGate->Set(Relay::kReverse);
  }
  else {
	ballGate->Set(Relay::kOff);
  }
}

// Limits the output to between -1 and 1.
float MyRobot::Limit(float input) {
  float output;
  
  if (input > 1) {
    output = 1;
  }
  else if (input < -1) {
    output = -1;
  }
  else {
    output = input;
  }
  
  return output;
}
